#include "mainwindow.h"
#include "ui_mainwindow.h"



void MainWindow::getDatabaseData(){
int list_count;

if (rootItems.isEmpty()) return;

list_count = rootItems.count();

for (int i=0; i < list_count; i++){

    buildTree(rootItems.at(i));

}

}

void MainWindow::buildTree(QTreeWidgetItem * model_item){




QString model_name;
QString rootClassID;
QString rootClassInctance;
QFont font;

QTreeWidgetItem * item;
model_name = model_item->text(0);
if (model_item->checkState(0) == false) return;

//font.setWeight(20);
font.setItalic(true);
item = new QTreeWidgetItem (ui->treeWidget_2);
item->setFont(0, font);
item->setText(0, model_name);
item->setTextColor(0, Qt::darkGreen);


rootClassID = model_item->child(0)->text(1);
rootClassInctance = getClassInctance(rootClassID);
if (model_item->child(0)->checkState(0)) //         ( ), 
    {
     /////   QTreeWidgetItem * item_tmp;
   /////     item_tmp = new QTreeWidgetItem(item);                  //  ,   ,   
   /////     item_tmp->setText(0, model_item->child(0)->text(0));    //   

        //showClassObjects(item_tmp, model_item->child(0));  //      

        ///// showObjects(item_tmp, model_item->child(0), tr(""));
    showObjects(item, model_item->child(0), tr(""));
    }


/*****************************************************/


}


//    -   
QString MainWindow::getClassInctance(QString class_id){
    QSqlQuery q;
    QString sql_str;
    QString result;
    QString classInctance;
    int field_inctance;
    bool ok;
    sql_str = tr("select * "
                 " from ListOfClasses where  ListOfClasses.ID = '"       // ,     
                 );
    sql_str.append(class_id);
     sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result;
                     }
    field_inctance = q.record().indexOf(tr("TableWhithInstance"));
    while(q.next()){

                  classInctance = q.value(field_inctance).toString();
                  result.append(classInctance);
                  }

  return result;

}

void MainWindow::showClassObjects(QTreeWidgetItem * parent_item, QTreeWidgetItem * model_item){
    QString classID; //  
    QString inctance; //  , 
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    bool ok;
    int field_ID;
    int i;
    classID = model_item->text(1);
    inctance = getClassInctance(classID);

    sql_str = tr("select * "
                 " from "       //      -   
                 );
    sql_str.append(inctance);
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return;
                     }

    field_ID = q.record().indexOf(tr("ID"));


    while(q.next()){
                  if (q.record().count() > 1)
                  {
                    QString value_tmp;
                    QString ID_tmp;
                    QTreeWidgetItem * itm;
                    ID_tmp = q.value(field_ID).toString(); //   
                    value_tmp = q.value(1).toString(); //    (    )
                    itm = new QTreeWidgetItem(parent_item); //    ,  
                    itm->setText(0, value_tmp);
                    for (int i; i < model_item->childCount(); i++) // ,      
                    {
                        QTreeWidgetItem * model_item_tmp;           //  
                        model_item_tmp = model_item->child(i);      //    
                        MainWindow::showObjectChildrens(ID_tmp, itm, model_item_tmp);

                    }
                  }

             }

    
    i++;
}



void MainWindow::showObjectChildrens(QString object_ID, QTreeWidgetItem * object_item, QTreeWidgetItem * model_item){ //   

    QString classID; //  

    QString inctance; //  , 
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    bool ok;
    classID = model_item->text(1);
    inctance = getClassInctance(classID);

    sql_str = tr("select * "
                 " from '"       //      -   
                 );
    sql_str.append(inctance);
    sql_str.append(tr("' where "));


    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return;
                     }
}


void MainWindow::showObjects(QTreeWidgetItem * parent_object_item, QTreeWidgetItem * model_item, QString filtr){
    QString classID; //  
    QString inctance; //  , 
    QString className; //  
    int field_ID;
    bool filtr_empty;
    bool ok;
    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QTreeWidgetItem * title_item;
    QFont font;
   // font.setWeight(40);
    font.setBold(true);
    filtr_empty = filtr.isEmpty();
    classID = model_item->text(1);
    className = model_item->text(0);
    inctance = getClassInctance(classID);

    title_item = new  QTreeWidgetItem(parent_object_item);
    title_item->setFont(0, font);
    title_item->setText(0, className);
    title_item->setText(1, tr("class"));
    title_item->setText(2, classID);
    title_item->setText(3, inctance);
    title_item->setTextColor(0, Qt::darkBlue);

    sql_str = tr("select * "
                 " from "       //      -   
                 );
    sql_str.append(inctance);
    if (!filtr.isEmpty())   { //    
                                 sql_str.append(tr(" "));
                                 sql_str.append(filtr); //    
                            }

    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return;
                     }

    field_ID = q.record().indexOf(tr("ID"));

    /*
    if (q.size() <= 0) return;
    title_item = new  QTreeWidgetItem(parent_object_item);
    title_item->setFont(0, font);
    title_item->setText(0, className);
    */

    while(q.next()){
                  if (q.record().count() > 1)
                  {
                    QString value_tmp;
                    QString ID_tmp;
                    QTreeWidgetItem * itm;
                    ID_tmp = q.value(field_ID).toString(); //   
                    value_tmp = q.value(1).toString(); //    (    )
               //     itm = new QTreeWidgetItem(parent_object_item); //    ,  
                    itm = new QTreeWidgetItem(title_item); //    ,  
                    itm->setText(0, value_tmp);
                    itm->setText(1, tr("object"));
                    itm->setText(2, ID_tmp);
                    for (int i=0; i < model_item->childCount(); i++) // ,      
                    {
                        QTreeWidgetItem * model_item_tmp;           //  
                        QString pointer_name;
                        QString filtr_tmp;
                        bool pointer_isEmpty;
                        model_item_tmp = model_item->child(i);      //    
                        pointer_name = getPointerFieldName(classID, model_item->child(i)->text(1));
                        itm->setText(4, pointer_name);
                        pointer_isEmpty = pointer_name.isEmpty();
                        filtr_tmp = tr("where ");
                        filtr_tmp.append(tr("`"));
                        filtr_tmp.append(pointer_name);
                        filtr_tmp.append(tr("` = '"));
                        filtr_tmp.append(ID_tmp);
                         filtr_tmp.append(tr("'"));
                        showObjects(itm,  model_item_tmp, filtr_tmp);
                        //MainWindow::showObjectChildrens(ID_tmp, itm, model_item_tmp);

                    }


                }

              }




    for (int i; i < model_item->childCount(); i++) // ,      
        {


        }

}


QString MainWindow::getPointerFieldName(QString parent_class_id, QString chield_class_id){

    QSqlQuery q;
    QString sql_str;
    QString str_tmp;
    QString field;
    QString result;
    int field_name;
    bool ok;
    sql_str = tr("select * "
                 " from `DescriptionOfClasses` where `DescriptionOfClasses`.`FieldType` = 'pointer' and  `DescriptionOfClasses`.`DefaultValue` = "       //      -   
                 );

    sql_str.append(tr("'"));
    sql_str.append(parent_class_id);
    sql_str.append(tr("' "));
    sql_str.append(tr(" and  `DescriptionOfClasses`.`ClassIdentifer` = '"));
    sql_str.append(chield_class_id);
    sql_str.append(tr("'"));
    q.prepare(sql_str);

    ok = q.exec();
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                                                                            return result;
                     }
field_name =  q.record().indexOf(tr("FieldName"));
while(q.next()){
        result = q.value(field_name).toString();
    }
return result;
}



void MainWindow::on_treeWidget_2_itemClicked ( QTreeWidgetItem * item, int column ){
QString item_type; //   (   )
QString parent_object_id;
int i;
QTreeWidgetItem * parent_item;
item_type = item->text(1);
parent_item = item->parent();
if (item_type == tr("object"))
    {
        QString  class_id;
        QString ID;
        QString inctance;
        QString filtr_tmp;
        class_id = parent_item->text(2);
        ID = item->text(2);
        inctance = parent_item->text(3);
        delete sql_mogel;
        sql_mogel = new QSqlTableModel();
//        sql_mogel = new QSqlTableModel(this);
        sql_mogel->setTable(inctance);
        sql_mogel->setEditStrategy(QSqlTableModel::OnFieldChange);

        filtr_tmp.append(tr("`"));
        filtr_tmp.append(tr("ID"));
        filtr_tmp.append(tr("`"));
        filtr_tmp.append(tr(" = '"));
        filtr_tmp.append(ID);
        filtr_tmp.append(tr("'"));
        sql_mogel->setFilter(filtr_tmp);
        sql_mogel->select();
        ui->tableView->setModel(sql_mogel);

        //sql_mogel->clear();
        //sql_mogel->select();
     //   ui->tableView->setVisible(false);
     //   i++;
    }
if (item_type == tr("class"))
    {
        QString parent_object_id; //   
        QString class_id; //   
        QString inctance;
        QString pointer_name;
        QString filtr_tmp;
   //     sql_mogel->clear();

        parent_object_id = parent_item->text(2);
        class_id = item->text(2);
        inctance = item->text(3);
        pointer_name = parent_item->text(4);

        delete sql_mogel;
        sql_mogel = new QSqlTableModel();
//        sql_mogel = new QSqlTableModel(this);
        sql_mogel->setTable(inctance);
        sql_mogel->setEditStrategy(QSqlTableModel::OnFieldChange);

        if (!parent_object_id.isEmpty())
        {
            filtr_tmp.append(tr("`"));
            filtr_tmp.append(pointer_name);
            filtr_tmp.append(tr("`"));
            filtr_tmp.append(tr(" = '"));
            filtr_tmp.append(parent_object_id);
            filtr_tmp.append(tr("'"));
            sql_mogel->setFilter(filtr_tmp);
        }
        sql_mogel->select();

        ui->tableView->setModel(sql_mogel);

   //     ui->tableView->setVisible(true);;
        i++;
    }

//parent_object_id = parent_object_item->text(1);





i++;

}


